import "Turbine";

AddEventHandler = function(object, event, f)
	if object[event] == nil then
		object[event] = { };
	elseif type(object[event]) ~= "table" then
		object[event] = { object[event] };
	end

	table.insert(object[event], f);
	return f;
end

RemoveEventHandler = function(object, event, handle)
	if object[event] ~= nil then
		for i = 1, table.getn(object[event]), 1 do
			if object[event][i] == handle then
				table.remove(object[event], i);
				break;
			end
		end
	end
end

AddChatHandler = function(f, type, sender)
	local h;

	if sender ~= nil and type ~= nil then
		h = function(self, args)
			if args.Sender == sender and args.ChatType == type then
				f(args.Message, args.Sender, args.ChatType);
			end
		end;
	elseif sender ~= nil then
		h = function(self, args)
			if args.Sender == sender then
				f(args.Message, args.Sender, args.ChatType);
			end
		end;
	elseif type ~= nil then
		h = function(self, args)
			if args.ChatType == type then
				f(args.Message, args.Sender, args.ChatType);
			end
		end;
	else
		h = function(self, args)
			f(args.Message, args.Sender, args.ChatType);
		end;
	end

	AddEventHandler(Turbine.Chat, "Received", h);
	return h;
end

RemoveChatHandler = function(h)
	RemoveEventHandler(Turbine.Chat, "Received", h);
end